
// rev 06-09-2017

extern sfr sbit DHT22_Pin;
extern sfr sbit DHT22_Pin_Out;
extern sfr sbit DHT22_Pin_Direction;
unsigned short DHT22_Check_Presence, Temp_1, Temp_2, RH_1, RH_2, DHT22_Checksum;
unsigned long DHT22_All;


unsigned char DHT22_Read_Byte(void)
{  char i,j;
     for(j = 0; j < 8; j++)
     {
       while(!DHT22_Pin);
       Delay_us(30);
       if(DHT22_Pin == 0)
           i&= ~(1<<(7 - j));
           else
           {
              i|= (1 << (7 - j));
              while(DHT22_Pin);
           }
     }
     return(i);
}     

unsigned long DHT22_Read_All_Data()
{
 DHT22_Pin_Direction = 0;
  DHT22_Pin_Out = 0;
  Delay_ms(20);
 DHT22_Pin_Out = 1;
  Delay_us(40);
  DHT22_Pin_Direction = 1;
 DHT22_Check_Presence = 0;
 Delay_us(20);
 if (DHT22_Pin == 0)
  { 
  Delay_us(80);
  if (DHT22_Pin == 1)   DHT22_Check_Presence = 1;
  Delay_us(40);
  }
  if (DHT22_Check_Presence == 1)
  {
     RH_1 = DHT22_Read_Byte();
     RH_2 = DHT22_Read_Byte();
     Temp_1 = DHT22_Read_Byte();
     Temp_2 = DHT22_Read_Byte();
     DHT22_Checksum = DHT22_Read_Byte();
     if(DHT22_Checksum == ((RH_1+RH_2+Temp_1+Temp_2) & 0XFF))
       {
       DHT22_All = RH_1;
       DHT22_All = (DHT22_All << 8) | RH_2;
       DHT22_All = (DHT22_All << 8) | Temp_1;
       DHT22_All = (DHT22_All << 8) | Temp_2;
       }
      else
      {
      DHT22_All = 0x58585858;
      }
   }
  else 
  {
  DHT22_All = 0x63636363;
  }
 return DHT22_All;
}