
#define Version "170906"
#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_18F26K22_DHT_Humidity_Temper "
#define Project "DHT22_test_18F26K22.mcppi"
#define Source  "_18F26K22_DHT22_test_"

#define Eeprom "18F26K22_DHT22_test_Eeprom.ihex"
#define Config "18F26K22_Fosc_interne_16MHz.cfgsch"
/*
CONFIG1H : $300001 : 0x0028
CONFIG2L : $300002 : 0x0019
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x00BE
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040
*/

#define PROCESSOR "18F26K22"
#define OSCILLATEUR_INTERNE
#define POWER_SUPPLY  " 5V"
#define FOSC "16.0"  // MHz
#define BAUD 19200  // UART1
#define CLS 12
#define CR 0x0D
#define LF 10
#define TAB 9
#define BACK 8
#define Beep 7
#define Separator 0x20   // space
#define LCD4x20_I2

 // cde relais inversée
 #define ON 0
 #define OFF 1

#ifndef Byte
#define Byte unsigned char
#endif

#ifndef Word
#define Word unsigned int
#endif

#define LCD_ADDR 0x4E     // PCF8574 on pigboard YwRobot back located  on LCD4x20
#define PCF8574_2_ADDR 0x46   // PCF8574 on breadboard drives  8 leds --R--- +5V
#define DS1307_ADDR 0xD0 // RTC DS1307
#define EEPROM_32K_ADR 0xA0 // EEPROM 24LC256
#define DHT22



sbit PB1 at PORTB.B1;
sbit PB2 at PORTB.B2;
sbit PB1_Dir at TRISB.B1;
sbit PB2_Dir at TRISB.B2;
// nota: RB0 reserved , because used for detecting action on  BP
// RB3 => reserved for PWM output
sbit PB4 at PORTB.B4;
sbit PB4_Dir at TRISB.B4;


// to use SQ50
sbit Synchro_SQ50 at LATA.B3;
sbit Synchro_SQ50_Dir at TRISA.B3;

sbit Pump_Relay at LATA4_bit;
sbit Pump_Relay_Dir at TRISA4_bit;
sbit RTC_forcee at PORTA.B5;
sbit RTC_forcee_Dir at TRISA.B5;
  // DHT22 sensor connections
sbit DHT22_Pin at PORTC.B0;
sbit DHT22_Pin_Direction at TRISC0_bit;
sbit DHT22_Pin_Out at LATC.B0 ;

// Specifique  DHT22 AM2302 O.W.S. sensor

 // Hardware
 /*
 Pin 28 RB7  -----------------ICSP Data
 Pin 27 RB6  -----------------ICSP Clock
 Pin 26 RB5
 Pin 25 RB4
 Pin 24 RB3  -----------------> PWM Output CCP3
 Pin 23 RB2
 Pin 22 RB1
 Pin 21 RB0
 Pin 20      VDD --------+5V
 Pin 19      Vss ---------Gnd
 Pin 18  RC7  RX UART  <-- Keyboard   * mettre pull up de 2,7K si alim 3,6V et cordon Prolic 5V
 Pin 17  RC6  TX UART  --> Display    * mettre une pull up de 2.7 si RX non utilisée
 Pin 16  RC5
 Pin 15  RC4 SDA <-----------> RTC 1307   --- EEPROM 24C32 ---- LCD 4x20

 Pin 14 RC3  SCL  -->-------- RTC 1307  -----EEPROM 24C32
 Pin 13 RC2
 Pin 12 RC1
 Pin 11 RC0 <--------> OWS DHT22 AM2302 Humidity Temperature Sensor
 Pin 10 RA6
 Pin  9 RA7
 Pin  8 VSS ---------  Gnd
 Pin  7 RA5  <------- Forcage RTC
 Pin  6 RA4  Output --Pump Relay--+Vcc
 Pin  5 RA3
 Pin  4 RA2  Analog Input
 Pin  3 RA1  Analog input EA1
 Pin  2 RA0  Analog Input EA0
 Pin  1 RE3 MCLR  Reset --------ICSP PGRM
*/

const code char mesg0[]="                   ";
const code char mesg1[]=" Directory :"Directory"\r\n";
const code char mesg2[]=" MikroC pro 7.10 \n\r";
const code char mesg3[] =" Projet :"Project"\r\n";
const code char mesg4[]=" Test Sensor DHT22 \r\n";
const char char mesg5[]=" Config bit : "Config"\r\n";
const char char mesg6[]=" Eeprom: "Eeprom"\r\n";
const char char mesg7[]=" Source : "Source"_"Version".c\r\n";
const char char mesg8[]=" avec : DHT22_AM2302_Sensor_1709.inc \r\n";
const char char mesg9[]=" et LCD_4x20_I2C_1709.inc\r\n";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9};
const char Blancs[]="  ";

char Jour_En_Cours[]="Dimanche";
const code char Jour0[]="Dimanche";
const code char Jour1[]="Lundi";
const code char Jour2[]="Mardi";
const code char Jour3[]="Mercredi.";
const code char Jour4[]="Jeudi";
const code char Jour5[]="Vendredi";
const code char Jour6[]="Samedi";
const code char * JourSemaine[]={Jour0,Jour1,Jour2,Jour3,Jour4,Jour5,Jour6};


#define MAX_LEN1 128
#define MAX_LEN2 32
#define MAX_LEN3 80


unsigned char Buffer1[MAX_LEN1];
volatile int Flag_Buffer1;
volatile unsigned char c1;
volatile unsigned int i1;
volatile unsigned int Index1;
volatile unsigned int CptErr;
unsigned char * p1;
//unsigned char * p2;
//unsigned char * p3;
volatile unsigned int Count0=0;
volatile int Flag_Timer0=0;
volatile int Flag_PB_Pusched=0;
// pour probleme de compatibilité avec fichier include RTC
#define buffer Buffer1
#define Flag_Buffer Flag_Buffer1



unsigned int i,j,k,l,m,n;
unsigned char TEXTE [MAX_LEN3];
unsigned char *txt;
unsigned char CRam1[MAX_LEN2];
int EA0,EA2;
unsigned int EA1;
int SEA0,SEA2;
unsigned int SEA1;
unsigned int Indice;
float Battery_Volt;
float F0,F1;
unsigned long L1;
unsigned int Nb=0;


//unsigned char Adr=0;
unsigned char I2C_Adresses_Devices[8];

 unsigned int Temp, RH ;
 unsigned long value;
 const char degree[] = {14,10,14,0,0,0,0,0};

 
char time[]="00:00:00";
char date[]="00/00/00";
int Etat;
unsigned char Adr;


void Init_Hardware(void) ;
void CRLF(void) ;
void Raz_Buffer(void) ;
void UART1_Write_CText(const char *txt);
void strConstRamCpy(unsigned char *dest, const code char *source);
void Float2Ascii (float x, unsigned char *chaine,char precision) ;
void Print_Msg_Eeprom( int debut);

 #include "_LCD_4x20_I2C_1709.c"
 #include "DHT22_AM2302_Sensor_1709.c"



// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF()
{
 UART1_Write(CR); UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 { char cx;
   cx=*(txt);
   while (cx>0)
   {  cx=*(txt++);
      UART1_Write(cx);
     Delay_us(50);

      }
}

void Raz_Buffer1()
{
        // nettoye le debut de buffer ,car utilis pour init BT
        for(i1=0;i1<MAX_LEN1-1;i1++) Buffer1[i1]=0;
        Buffer1[0]=0;
        i1=0;
        p1=0;
        Index1=0;
        Flag_Buffer1 =0 ;
        c1=RCREG1;
        c1=0;
        RC1IE_bit = 1;
}


void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
}

void Print_Msg_Eeprom( int debut)
{   int i1 ,i;
  i1=debut;
  do
  {
  i = EEPROM_Read(i1);
  if ( i==0) break;
  if ( i1>1023) break;
  UART1_Write(i);
  Delay_ms(5);
  i1++;
   }
  while (i!=0) ;
 }





void Init_Hardware()
{

  PORTA = 0x00;
  ANSELA=0;
  ANSELA.ANSA0=1;    //  analog input on Port RA0   voir page 154
  ANSELA.ANSA1=1;    //  analog input on Port RA1
  ANSELA.ANSA2=1;     //  analog input on Port RA2
  TRISA = 0b11100111 ;   // PORTA is RA0,1= analog input  ... RA3,  RA4, RA5  =Digital output
  
  Pump_Relay_Dir=0;
  Pump_Relay=OFF  ;   // 1=OFF  0=ON
  RTC_forcee_Dir=1;
  Synchro_SQ50_Dir=0;
  Synchro_SQ50=0;

  ANSELB=0;
  PORTB = 0xFF;
  TRISB = 0xFF;    //  B0..B7 input   ATTENTION B7 B6 for ICSP Pickit3
 //Alternate pin assignment for P2B, T3CKI, CCP3 and CCP2 when Configuration bits PB2MX, T3CMX, CCP3MX andC CP2MX are clear.
 // config bits :  CCP2MX: CCP2 MUX bit
 // CONFIG3H : $300005 : 0x00BE  <- config 0xBE  RB3 pour sortie PWM2 sinon 0xBF pour RC1
 // CONFIG3H : $300005 : 0x00BE
 // Table 10-5 page 142  RB3        CCP2(2) 0 0 O DIG Compare 2 output/PWM 2 output.
  TRISB3_bit=0;   // P2A PWM output for PWM2
  PB1_Dir=1;
  PB2_Dir=1;
  PB4_Dir=1;
  
  CM1CON0=0;
  CM2CON0=0;

  LATC=0x00;
  PORTC=0;
  ANSELC=0; 
  TRISC=0xFF;
  TRISC.TRISC3 = 1;  // SCL I2C
  TRISC.TRISC4 = 1;  // SDA I2C
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1
  TRISC.TRISC1 = 0;  // output to BT HC06 reset
  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }


void I2C1_TimeoutCallback(char errorCode)
{
   if (errorCode == _I2C_TIMEOUT_RD) {
     // do something if timeout is caused during read
   }
   if (errorCode == _I2C_TIMEOUT_WR) {
     // do something if timeout is caused during write
   }
   if (errorCode == _I2C_TIMEOUT_START) {
     // do something if timeout is caused during start
   }
   if (errorCode == _I2C_TIMEOUT_REPEATED_START) {
     // do something if timeout is caused during repeated start
   }
}



void degreeChar(char pos_row, char pos_char) 
{
  char i;
   LCD_Cmd(64);
   for (i = 0; i<=7; i++) LCD_putch(degree[i]);
    LCD_Cmd( LCD_HOME);
   LCD_Chr(pos_row, pos_char, 0);
     Delay_ms(25);
}



void main() 
{
  OSCCON.IRCF2=1; //HFINTOSC - (16 MHz)
  OSCCON.IRCF1=1;
  OSCCON.IRCF0=1;
  OSCCON.SCS1=1;
  OSCCON.SCS0=0;
  OSCTUNE=0;
  OSCTUNE.PLLEN=0;  // 1= avec PLL => 64Mhz ou 40Mhz   0 =sans PLL => 16Mhz

  Init_Hardware() ;

  //init des tables pour etre sur de ne pas avoir d'effet de bords
  // avec variables declarées ,mais non initialisées
  for (i=0;i<MAX_LEN1;i++) Buffer1[i]=0;
  for (i=0;i<MAX_LEN2;i++) CRam1[i]=0;
  for (i=0;i<MAX_LEN3;i++) TEXTE[i]=0;
  i=0;
  txt=&TEXTE[0];

  UART1_Init(19200);  //HC06 Bleu 3.3v
  Delay_ms(500);
  UART1_Write(CLS);   // Erase screen terminal  :it is an option on Vbray Terminal!
  Delay_ms(500);
  CRLF();
  UART1_Write_CText(" Presentation : \r\n");
  for (i=1;i<8;i++)   UART1_Write_CText(Messages[i]);
  UART1_Write_CText(" (C) ");Print_Msg_Eeprom(0x0000);
  Delay_ms(1000);
  CRLF();


  UART1_Write_CText(" Init I2C 100Khz \r\n");
  I2C1_Init(100000);
  I2C1_Stop();
  I2C1_SetTimeoutCallback(1000, I2C1_TimeoutCallback);

    Delay_ms(2000);
   // adrr= adresse du PCF8754 du LCD4x20
  Adr=LCD_ADDR;
  LCD_init_4x20();
  LCD_Cmd(LCD_CLEAR);  // LCD Clear
 Delay_ms(200);
  LCD_Out(3, 1, "DHT22 OWS test 16MHz");
  LCD_Out(4, 1, "18F26K22 LCD4x20 I2C");
   while(1)
   {
  Synchro_SQ50=1;
   value = DHT22_Read_All_Data();
  //  value = My_DHT22_ReadData(); // <-- BAD !
  Synchro_SQ50=0;
  if (value == 0x63636363){
   LCD_Out(1, 1, "  No response   ");
  LCD_Out(2, 1, "from the sensor ");
  }
  if (value == 0x58585858){
   LCD_Cmd(LCD_CLEAR);
   Delay_ms(25);
   LCD_Out(1, 1, "Check sum error ");
  }
  if ((value != 0x63636363) && (value != 0x58585858)) {
  Temp = value & 0xFFFF;
  value = value >> 16;
  RH = value & 0xFFFF;
  LCD_Out(1, 1, " Temp.Amb :   .   C ");
  LCD_Out(2, 1, " Humidite :   .   % ");
  if (Temp > 0X8000)
  {
  LCD_Out(1, 10, "-");
  Temp = Temp & 0X7FFF;
   }
  LCD_Chr(1, 13, 48 + ((Temp / 100) % 10));
  LCD_Chr(1, 14, 48 + ((Temp / 10) % 10));
  LCD_Chr(1, 16, 48 + (Temp % 10));
  degreeChar(1, 18);
  if (RH == 1000)  LCD_Chr(2, 12, 48 + ((RH / 1000) % 10));
  LCD_Chr(2, 13, 48 + ((RH / 100) % 10));
  LCD_Chr(2, 14, 48 + ((RH / 10) % 10));
  LCD_Chr(2, 16, 48 + (RH % 10));
   }
  //                  01234567890123456789012345678901234567890
  strConstRamCpy(txt,"Temp.Ambiante=   .  C  Humidite=   .  %\r\n");
  WordToStr(Temp,CRam1);
  k=strlen(CRam1);
  *(txt+18)=*(CRam1+k-1) ;
  *(txt+16)=*(CRam1+k-2);
  *(txt+15)=*(CRam1+k-3);
  UART1_Write(TAB);
  WordToStr(RH,CRam1);
  k=strlen(CRam1);
  *(txt+37)=*(CRam1+k-1) ;
  *(txt+35)=*(CRam1+k-2);
  *(txt+34)=*(CRam1+k-3);
  UART1_Write_Text(txt);
  Delay_ms(1000);
  }
}
/*


 Presentation :
 Directory :C:\_MikroC\_MesProjets_MikroC\_18F26K22_DHT_Humidity_Temper
 MikroC pro 7.10
 Projet :DHT22_test_18F26K22.mcppi
 Test Sensor DHT22
 Config bit : 18F26K22_Fosc_interne_16MHz.cfgsch
 Eeprom: 18F26K22_DHT22_test_Eeprom.ihex
 Source : _18F26K22_DHT22_test__170905.c
 (C) (C)) paulfjujo.free.fr

 Init I2C 100Khz
        Temp.Ambiante= 24.1 C  Humidite= 62.4 %
        Temp.Ambiante= 24.1 C  Humidite= 62.3 %
        Temp.Ambiante= 24.1 C  Humidite= 62.3 %
        Temp.Ambiante= 24.1 C  Humidite= 62.3 %
        Temp.Ambiante= 24.1 C  Humidite= 62.3 %
        Temp.Ambiante= 24.1 C  Humidite= 62.2 %
   =================================
 Presentation :
Directory :C:\_MikroC\_MesProjets_MikroC\_18F26K22_DHT_Humidity_Temper
 MikroC pro 7.10
 Projet :DHT22_test_18F26K22.mcppi
 Test Sensor DHT22
 Config bit : 18F26K22_Fosc_interne_16MHz.cfgsch
 Eeprom: 18F26K22_DHT22_test_Eeprom.ihex
 Source : _18F26K22_DHT22_test__170905.c
 (C) (C)) paulfjujo.free.fr

 Init I2C 100Khz
        Temp.Ambiante= 25.5 C  Humidite= 54.8 %
        Temp.Ambiante= 25.4 C  Humidite= 54.8 %
        Temp.Ambiante= 25.4 C  Humidite= 54.8 %
        Temp.Ambiante= 25.4 C  Humidite= 54.8 %
        Temp.Ambiante= 25.4 C  Humidite= 54.8 %
        Temp.Ambiante= 25.4 C  Humidite= 54.8 %
        Temp.Ambiante= 25.4 C  Humidite= 54.8 %
        Temp.Ambiante= 25.4 C  Humidite= 54.8 %
        Temp.Ambiante= 25.4 C  Humidite= 54.8 %
        Temp.Ambiante= 25.4 C  Humidite= 54.8 %
        */